/************************************************************************
    Coin Graphics header
    
/***********************************************************************/


extern ULONG gCoinAnimSector;
extern char *gCoinTossFile;
//extern SVECTOR gSpiralCameraOffset;

/*-------------------------------------------------------------
  DoCoinPickFlipMenu ~ 
   on: 1=Show & Update,  0=Hide
   team: 0=home, 1=visitor
   return: 0 = Not picked yet,
		1 = Heads, 2 = Tails
-------------------------------------------------------------*/
int DoCoinPickFlipMenu(int on, int team);

/*-------------------------------------------------------------
  DoCoinPickFirstMenu ~ Winner of flip
   Receiver, Kick, Which side
   on: 1=Show & Update,  0=Hide
   team: 0=home, 1=visitor
   return: 0 = Not picked yet,
		1 = Kick, 2 = receive, 3 = side
-------------------------------------------------------------*/
int DoCoinPickFirstMenu(int on, int team);


/*-------------------------------------------------------------
  DoCoinPickSideMenu ~ 
   on: 1=Show & Update,  0=Hide
   team: 0=home, 1=visitor
   return: 0 = Not picked yet,
		1 = West, 2 = East
-------------------------------------------------------------*/
int DoCoinPickSideMenu(int on, int team);

/*-------------------------------------------------------------
  DoCoinPickReceiveMenu ~ 
   on: 1=Show & Update,  0=Hide
   team: 0=home, 1=visitor
   return: 0 = Not picked yet,
		1 = Kick 2 = receive
-------------------------------------------------------------*/
int DoCoinPickReceiveMenu(int on, int team);


/*-------------------------------------------------------------
  DoCoinFlippingGraphic ~ 
-------------------------------------------------------------*/
int DoCoinFlippingGraphic(void);

