#*****************************************************************
#   Fast Decompression routines 
#
#   Optimized from compiled C by Christopher Deel
#
#*****************************************************************
	.file	1 "decomp.c"

 # GNU C 2.6.3.SN.2 [AL 1.1, MM 40] Sony Playstation compiled by GNU C

 # Cc1 defaults:
 # -mgas -msoft-float

 # Cc1 arguments (-G value = 8, Cpu = 3000, ISA = 1):
 # -quiet -O3 -o

gcc2_compiled.:
__gnu_compiled_c:
	.text
	.align	2
	.globl	DecompressFrame
	.align	2
	.globl	DecompressFrameShorts
	.align	2
	.globl	DecompressFrameBytes

	.text

#------------------------------------------	
#------------------------------------------
	.ent	DecompressFrame
DecompressFrame:
	.frame	$sp,0,$31		# vars= 0, regs= 0/0, args= 0, extra= 0
	.mask	0x00000000,0
	.fmask	0x00000000,0
	li	$8,0x7fff0000		# 2147418112
	ori	$8,$8,0xffff
	lw	$3,0($5)
	addu	$5,$5,4
	.set	noreorder
	.set	nomacro
	beq	$3,$0,$L18
	li	$9,-2147483648			# 0x80000000
	.set	macro
	.set	reorder

	li	$7,-1			# 0xffffffff
$L19:
	and	$2,$3,$9
	beq	$2,$0,$L20
	lw	$2,0($5)
	and	$3,$3,$8
	.set	noreorder
	.set	nomacro
	beq	$3,$7,$L25
	addu	$5,$5,4
	.set	macro
	.set	reorder

#	li	$6,-1			# 0xffffffff #CGD
$L23:
	sw  	$2,0($4)
	addu	$3,$3,-1
	.set	noreorder
	.set	nomacro
	bne 	$3,$7,$L23		#CGD
	addu	$4,$4,4
	.set	macro
	.set	reorder

	j	$L25
$L20:
	addu	$3,$3,-1
	beq	$3,$7,$L25
	nop						#CGD
#	li		$6,-1			# 0xffffffff #CGD
$L28:
	lw		$2,0($5)
	addu	$5,$5,4
	addu	$3,$3,-1
	sw		$2,0($4)
	.set	noreorder
	.set	nomacro
	bne		$3,$7,$L28
	addu	$4,$4,4
	.set	macro
	.set	reorder

$L25:
	lw	$3,0($5)
	#nop
	.set	noreorder
	.set	nomacro
	bne 	$3,$0,$L19
	addu	$5,$5,4
	.set	macro
	.set	reorder

$L18:
	j	$31
	.end	DecompressFrame
	

#------------------------------------------	
#------------------------------------------
	.ent	DecompressFrameShorts
DecompressFrameShorts:
	.frame	$sp,0,$31		# vars= 0, regs= 0/0, args= 0, extra= 0
	.mask	0x00000000,0
	.fmask	0x00000000,0
	lhu	$3,0($5)
	#nop
	.set	noreorder
	.set	nomacro
	beq	$3,$0,$L48
	addu	$5,$5,2
	.set	macro
	.set	reorder

	li	$9,0x00008000		# 32768
	li	$8,0x00007fff		# 32767
	li	$7,-1			# 0xffffffff
$L49:
	and	$2,$3,$9
	beq	$2,$0,$L50
	lhu	$2,0($5)
	and	$3,$3,$8
	.set	noreorder
	.set	nomacro
	beq	$3,$7,$L55
	addu	$5,$5,2
	.set	macro
	.set	reorder

#	li	$6,-1			# 0xffffffff  #not needed CGD
$L53:
	sh	$2,0($4)
	addu	$3,$3,-1
	.set	noreorder
	.set	nomacro
	bne	$3,$7,$L53
	addu	$4,$4,2
	.set	macro
	.set	reorder

	j	$L55
$L50:
	addu	$3,$3,-1
	beq	$3,$7,$L55
	nop					#CGD
#	li	$6,-1			# 0xffffffff  # CGD
$L58:
	lhu	$2,0($5)
	addu	$5,$5,2
	addu	$3,$3,-1
	sh	$2,0($4)
	.set	noreorder
	.set	nomacro
	bne	$3,$7,$L58
	addu	$4,$4,2
	.set	macro
	.set	reorder

$L55:
	lhu	$3,0($5)
	#nop
	.set	noreorder
	.set	nomacro
	bne	$3,$0,$L49
	addu	$5,$5,2
	.set	macro
	.set	reorder

$L48:
	j	$31
	.end	DecompressFrameShorts
	
	
#------------------------------------------	
#------------------------------------------
	.ent	DecompressFrameBytes
DecompressFrameBytes:
	.frame	$sp,0,$31		# vars= 0, regs= 0/0, args= 0, extra= 0
	.mask	0x00000000,0
	.fmask	0x00000000,0
	lbu	$3,0($5)
	#nop
	.set	noreorder
	.set	nomacro
	beq	$3,$0,$L78
	addu	$5,$5,1
	.set	macro
	.set	reorder

	li	$9,0x00000080		# 128
	li	$8,0x0000007f		# 127
	li	$7,-1			# 0xffffffff
$L79:
	and 	$2,$3,$9
	beq 	$2,$0,$L80
	lbu 	$2,0($5)
	and 	$3,$3,$8
	.set	noreorder
	.set	nomacro
	beq 	$3,$7,$L85
	addu	$5,$5,1
	.set	macro
	.set	reorder

#	li  	$6,-1			# 0xffffffff  (Not Needed  CGD)
$L83:						#Copy Loop
	sb  	$2,0($4)
	addu	$3,$3,-1
	.set	noreorder
	.set	nomacro
	bne 	$3,$7,$L83		# Changed $6 to $7 CGD
	addu	$4,$4,1
	.set	macro
	.set	reorder

	j	$L85
$L80:
	addu	$3,$3,-1
	beq	$3,$7,$L85
	nop					# Nop Filler CGD
#	li	$6,-1			# 0xffffffff  (not needed CGD)

$L88:
	lbu 	$2,0($5)
	addu	$5,$5,1
	addu	$3,$3,-1
	sb  	$2,0($4)
	.set	noreorder
	.set	nomacro
	bne 	$3,$7,$L88		#changed $6 to $7 CGD
	addu	$4,$4,1
	.set	macro
	.set	reorder

$L85:
	lbu 	$3,0($5)
	#nop
	.set	noreorder
	.set	nomacro
	bne 	$3,$0,$L79
	addu	$5,$5,1
	.set	macro
	.set	reorder

$L78:
	j	$31
	.end	DecompressFrameBytes
