/**********************************************************************


					FBMovie.C

	INITIAL AUTHOR: M. Heilemann       Start Date: 8/3/96

	Modify Date:


	Copyright 1997  GameTek, Inc.



	This file routines to play the "correct" Jimmy movies depending
	on game results.

**********************************************************************/



#include "movie.h"


extern struct teamRAMstats StatsData[];

/*************************************************************************
 * PLAY POST GAME MOVIE - Figure out who wins and play their movie.
 *************************************************************************/
int PlayPostGameMovie(WORD i)
{
	register int   j;
	int 			  mul,
//					  winner,
					  possible_movies_high,
					  possible_movies;
	signed short  score;
	short			  movie_high[20],
					  movie[20];
//	unsigned long *ptr;

	score = GameTeamData[0].TotalScore - GameTeamData[1].TotalScore;

// BOTH TEAMS CPU RETURN
//	if (GameTeamData[0].ControllerNum[0] == -1 && GameTeamData[1].ControllerNum[0] == -1)
//		return(-1);
/***
// PLAY WIN SUPER BOWL MOVIE
	if (GameType == CHAMPIONSHIP_GAME)
		if ((GameTeamData[0].TeamNumber == HumanTeamNum && GameTeamData[0].TotalScore > GameTeamData[1].TotalScore) ||
			 (GameTeamData[1].TeamNumber == HumanTeamNum && GameTeamData[1].TotalScore > GameTeamData[0].TotalScore))
		{
			return(CHAMP_MOV);
		}
***/
// DO HUMAN TEAMS
//	for (i = 0; i < 2; i++)
//	{
//		if (GameTeamData[i].ControllerNum[0] == -1)
//			continue;	// Don't do CPU teams

// STANDARD SEASON & EXHIBITION SPECIFIC MOVIES
	if (randper < 80)	// 80% chance to play a specific movie
	{
		possible_movies_high = 0;
		possible_movies = 0;

		mul = GameOptions[GAME_OPTNS_QTR_LENGTH] * 2;
		if (!mul)
			mul = 1;

		if ((score > 0 && i == 0) || (score < 0 && i == 1))
		{
		// GOOD POINTS
			if (GameTeamData[i].TotalScore > 25 * mul)
				movie_high[possible_movies_high++] = GOOD_POINTS_MOV;
			else
			if (GameTeamData[i].TotalScore > 13 * mul)
				movie[possible_movies++] = GOOD_POINTS_MOV;
			else

		// GOOD FIRST DOWNS
			if (StatsData[i].allplyrstats[GS_1STDOWNS] > 9 * mul)
				movie_high[possible_movies_high++] = GOOD_FIRST_DOWNS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_1STDOWNS] > 6 * mul)
				movie[possible_movies++] = GOOD_FIRST_DOWNS_MOV;
			else

		// GOOD 4TH DOWNS
			if (StatsData[i].allplyrstats[GS_4THDOWNS_ATT])
				j = (StatsData[i].allplyrstats[GS_4THDOWNS_MADE] * 100) / StatsData[i].allplyrstats[GS_4THDOWNS_ATT];
			else
				j = 0;

			if (StatsData[i].allplyrstats[GS_4THDOWNS_ATT] > 2 * mul && j > 99)
				movie_high[possible_movies_high++] = GOOD_FOURTH_DOWNS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_4THDOWNS_ATT] > (3 * mul) / 2 && j > 74)
				movie[possible_movies++] = GOOD_FOURTH_DOWNS_MOV;
			else

		// GOOD TOTAL YARDS
			j = StatsData[i].allplyrstats[GS_PASS_YARDS] + StatsData[i].allplyrstats[GS_RUSH_YARDS];
			if (j > 200 * mul)
				movie_high[possible_movies_high++] = GOOD_TOTAL_YARDS_MOV;
			else
			if (j > 150 * mul)
				movie[possible_movies++] = GOOD_TOTAL_YARDS_MOV;
			else

		// GOOD PASSING YARDS
			if (StatsData[i].allplyrstats[GS_PASS_YARDS] > 125 * mul)
				movie_high[possible_movies_high++] = GOOD_PASS_YARDS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_PASS_YARDS] > 80 * mul)
				movie[possible_movies++] = GOOD_PASS_YARDS_MOV;
			else

		// GOOD PASS COMPLETE
			if (StatsData[i].allplyrstats[GS_PASS_ATT])
				j = (StatsData[i].allplyrstats[GS_PASS_COMP] * 100) / StatsData[i].allplyrstats[GS_PASS_ATT];
			else
				j = 0;

			if (StatsData[i].allplyrstats[GS_PASS_ATT] > 5 * mul && j > 80)
				movie_high[possible_movies_high++] = GOOD_PASS_PERCENT_MOV;
			else
			if (StatsData[i].allplyrstats[GS_PASS_ATT] > 5 * mul && j > 65)
				movie[possible_movies++] = GOOD_PASS_PERCENT_MOV;
			else

		// GOOD RUSHING YARDS
			if (StatsData[i].allplyrstats[GS_RUSH_YARDS] > 50 * mul)
				movie_high[possible_movies_high++] = GOOD_RUSH_YARDS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_RUSH_YARDS] > 25 * mul)
				movie[possible_movies++] = GOOD_RUSH_YARDS_MOV;
			else

		// GOOD PENALTYS - Only in normal mode, and never for 2 or 5 minute quarter
			if (StatsData[i].allplyrstats[GS_PENALTY_NUM] == 0 && GameOptions[GAME_OPTNS_QTR_LENGTH] > 1)
				movie[possible_movies++] = GOOD_PENALTY_MOV;
			else

		// GOOD SACKS
			if (StatsData[i].allplyrstats[GS_SACK_NUM] > 4 * mul)
				movie_high[possible_movies_high++] = GOOD_SACKS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_SACK_NUM] > 2 * mul)
				movie[possible_movies++] = GOOD_SACKS_MOV;
			else

		// GOOD TURNOVER - Only do in normal mode, and never for 2 or 5 minute quarter
			j = StatsData[i].allplyrstats[GS_PASS_INT] + StatsData[i].allplyrstats[GS_FUM_LOST];
			if (j > 2 * mul && GameOptions[GAME_OPTNS_QTR_LENGTH] > 1)
				movie_high[possible_movies_high++] = GOOD_TURNOVER_MOV;
			else
			if (j > mul && GameOptions[GAME_OPTNS_QTR_LENGTH] > 1)
				movie[possible_movies++] = GOOD_TURNOVER_MOV;
		}
		else
		{
		// BAD POINTS
			if (GameTeamData[i].TotalScore < mul / 2)
				movie_high[possible_movies_high++] = BAD_POINTS_MOV;
			else
			if (GameTeamData[i].TotalScore < (7 * mul) / 2)
				movie[possible_movies++] = BAD_POINTS_MOV;

		// BAD FIRST DOWNS
			if (StatsData[i].allplyrstats[GS_1STDOWNS] < mul)
				movie_high[possible_movies_high++] = BAD_FIRST_DOWNS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_1STDOWNS] < 2 * mul)
				movie[possible_movies++] = BAD_FIRST_DOWNS_MOV;

		// BAD 4TH DOWNS
			if (StatsData[i].allplyrstats[GS_4THDOWNS_ATT])
				j = (StatsData[i].allplyrstats[GS_4THDOWNS_MADE] * 100) / StatsData[i].allplyrstats[GS_4THDOWNS_ATT];
			else
				j = 0;

			if (StatsData[i].allplyrstats[GS_4THDOWNS_ATT] > (7 * mul) / 2 && j < 10)
				movie_high[possible_movies_high++] = BAD_FOURTH_DOWNS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_4THDOWNS_ATT] > (5 * mul) / 2 && j < 34)
				movie[possible_movies++] = BAD_FOURTH_DOWNS_MOV;

		// BAD TOTAL YARDS
			j = StatsData[i].allplyrstats[GS_PASS_YARDS] + StatsData[i].allplyrstats[GS_RUSH_YARDS];
			if (j < 7 * mul)
				movie_high[possible_movies_high++] = BAD_TOTAL_YARDS_MOV;
			else
			if (j < 15 * mul)
				movie[possible_movies++] = BAD_TOTAL_YARDS_MOV;

		// BAD PASSING YARDS
			if (StatsData[i].allplyrstats[GS_PASS_YARDS] < 5 * mul)
				movie_high[possible_movies_high++] = BAD_PASS_YARDS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_PASS_YARDS] < 20 * mul)
				movie[possible_movies++] = BAD_PASS_YARDS_MOV;

		// BAD PASS COMPLETE
			if (StatsData[i].allplyrstats[GS_PASS_ATT])
				j = (StatsData[i].allplyrstats[GS_PASS_COMP] * 100) / StatsData[i].allplyrstats[GS_PASS_ATT];
			else
				j = 0;

			if (StatsData[i].allplyrstats[GS_PASS_ATT] > 5 * mul && j < 10)
				movie_high[possible_movies_high++] = BAD_PASS_PERCENT_MOV;
			else
			if (StatsData[i].allplyrstats[GS_PASS_ATT] > 5 * mul && j < 20)
				movie[possible_movies++] = BAD_PASS_PERCENT_MOV;

		// BAD RUSHING YARDS
			if (StatsData[i].allplyrstats[GS_RUSH_YARDS] < 5 * mul && StatsData[i].allplyrstats[GS_RUSH_ATT] < 15)
				movie_high[possible_movies_high++] = BAD_RUSH_YARDS_MOV;
			else
			if (StatsData[i].allplyrstats[GS_RUSH_YARDS] < 20 * mul && StatsData[i].allplyrstats[GS_RUSH_ATT] < 15)
				movie[possible_movies++] = BAD_RUSH_YARDS_MOV;

		// BAD PENALTYS
			if (StatsData[i].allplyrstats[GS_PENALTY_NUM] > 7 * mul)
				movie_high[possible_movies_high++] = BAD_PENALTY_MOV;
			else
			if (StatsData[i].allplyrstats[GS_PENALTY_NUM] > 4 * mul)
				movie[possible_movies++] = BAD_PENALTY_MOV;

		// BAD SACKS - Only do in normal mode, and never for 2 minute quarter
			if (StatsData[i].allplyrstats[GS_SACK_NUM] == 0 && GameOptions[GAME_OPTNS_QTR_LENGTH])
				movie[possible_movies++] = BAD_SACKS_MOV;

		// BAD TURNOVER
			j = StatsData[i].allplyrstats[GS_PASS_INT] + StatsData[i].allplyrstats[GS_FUM_LOST];
			if (j == 0 && GameOptions[GAME_OPTNS_QTR_LENGTH])
				movie[possible_movies++] = BAD_TURNOVER_MOV;
		}


		if (possible_movies_high)	// If we get a real strong hit...
		{
			return(movie_high[randnum(possible_movies_high)]);
		}
		if (possible_movies)	// If we get a real strong hit...
		{
			return(movie[randnum(possible_movies)]);
		}

	}

	// GENERAL WIN/LOSS 20% or if NO relevant specific movies
	if ((score > 0 && score < 4 && i == 0)	||	(score < 0 && score > -4 && i == 1))
		return(POST_GAME_WIN_CLOSE_0_MOV + randnum(3));
	else
	if ((score > 3 && score < 15 && i == 0) || (score < -3 && score > -15 && i == 1))
		return(POST_GAME_WIN_GENERIC_0_MOV);
	else
	if ((score > 14 && i == 0) || (score < -14 && i == 1))
		return(POST_GAME_WIN_BLOWOUT_0_MOV + randnum(2));
	else
	if ((score > 0 && score < 4 && i == 1)	||	(score < 0 && score > -4 && i == 0))
		return(POST_GAME_LOSE_CLOSE_0_MOV + randnum(2));
	else
	if ((score > 3 && score < 15 && i == 1) || (score < -3 && score > -15 && i == 0))
		return(POST_GAME_LOSE_GENERIC_0_MOV + randnum(4));
	else
	if ((score > 14 && i == 1) || (score < -14 && i == 0))
		return(POST_GAME_LOSE_BLOWOUT_0_MOV);
	else
	if (score == 0)
		return(POST_GAME_WIN_CLOSE_0_MOV + randnum(2));
//	}
	return(-1);
}

/************************   End of File - FBMovie.c  *********************/