/***********************************************

				File: PrjTypes.H

	Copyright 1995  GameTek, Inc.


	TYPES for the PSX.

***********************************************/

#ifndef  _PRJTYPES_H
#define  _PRJTYPES_H 1

typedef unsigned    char    Uint8;
typedef signed      char    Sint8;
typedef unsigned    short   Uint16;
typedef signed      short   Sint16;
typedef unsigned    long    Uint32;
typedef signed      long    Sint32;
typedef float               Float32;
typedef double              Float64;

typedef unsigned char Ubyte;	/* 8 bit */
typedef unsigned char UBYTE;
typedef signed char BYTE;

typedef unsigned short Ushort;	/* 16 bit */
typedef unsigned short USHORT;
typedef unsigned short UWORD;
typedef short WORD;

typedef unsigned long Ulong;	/* 32 bit */
typedef unsigned long ULONG;
typedef long LONG;

typedef	int INT;

typedef int BOOL;		/* 8 bits */
typedef BOOL Bool;
typedef BOOL BOOLEAN;

typedef short Handle;

typedef INT (*FCNPTR)();	/* function pointer */

#define FALSE 0
//#define TRUE  !FALSE
#define TRUE 1	/* This should work for all types and generate less code */
#define True TRUE
#define False FALSE

#ifndef NULL
#define NULL 0
#endif

typedef struct
{
	short x, y;
} Point2DType;

typedef struct
{
	char u, v;
} UVType;

#endif  _PRJTYPES_H



/******************** End of File: PrjTypes.H  **********************/
