/*******************************************
	Coin Toss Logic  Header  (COINLOG.H)

*******************************************/


extern short CoinTossState ;

enum COIN_ENUM
{
	COIN_TOSS_NULL,
	COIN_TOSS_SPIRAL,
	COIN_TOSS_RUN_OUT,
	COIN_TOSS_PICK_FLIP,
	COIN_TOSS_FLIPPING,
	COIN_TOSS_PICK_FIRST,
	COIN_TOSS_PICK_RECEIVE,
	COIN_TOSS_PICK_SIDE,
	COIN_TOSS_RUN_BACK,
	COIN_TOSS_COMPLETE
};

#define CHOSE_NONE		0
#define CHOSE_KICK		1
#define CHOSE_RECEIVE	2
#define CHOSE_SIDE		3

#define CHOSE_HEADS		1
#define CHOSE_TAILS		2

#define CHOSE_EAST		1
#define CHOSE_WEST		2


/*-------- Coin Toss Flags --------*/
#if !COINLOG_C
extern unsigned char
#else
unsigned char
#endif
	CoinActiveFlag,
	CoinHeadsFlag, 
	CoinFlippedFlag,
	CoinVisitorKickFlag, 
	CoinVisitorEastFlag, 
	CoinVisitorPickingFlag,
	CoinPickedHeadsFlag,
	CoinVisitorWonFlag,
	CoinWinnerPickedSideFlag,
	CoinOvertimeFlag;


/* coinlog.c */
void InitCoinTossLogic ( void );
void StartCoinTossLogic ( void );
void DoCoinTossLogic ( void );
	