/***********************************************************************
	debugshl.h 					  	
	debug options screen			
									
	Programmed by Nicolas Antczak	
	Started on 3/14/1995			
	Copyright (C) 1995 GameTek, inc	
	
	Modifications					
		Chris Deel	7-16-96
************************************************************************/

/*structure declaration*/
struct DebugStruct
	{
		char *Name;	  //string printed on the screen                   
		int Value;	  //THE VALUE                                      
		int Min;		  //it's minimum                                   
		int Max;		  //it's max                                     
		int StringPtr; //used internaly, set to 0 when declaring array
	};

extern struct DebugStruct DebugShellVar[];
				  
#define DEBUG_SHELL_JNUM 19
				  
/*prototypes go here*/
void Display_Debug_Shell(int LoadFontsFlag);

int Paint_DBUG_Screen();
int CleanUp_DBUG(int LoadFontsFlag);
int Shell_Frame_DBUG(); 		 
void RefreshDebugScreen();
void ValidateDebugData();
void InitDebugData();
/*************************END OF FILE DBUGSHL.H**************************/
