/**************************************************************
					FBIRP.H

	AUTHOR: M. Knauer				Start Date: 11/5/96
	Modify Date:	All the time - by everyone

	Copyright 1995,1996,1997...  GameTek, Inc.

	This file contains all equate for size of Instant Replay Buffer

	It is an INCLUDED file in FBAudio.h.  (smallest "c" file)

	Also see FBEQU.h

	 Note:  size of IRP buffer changes daily

	MAJOR MOD.  11/19/96

	IRP now uses interpolation on the odd frames
	Odd frame data has only graphic attributes, not X,Y,Z
	Average X,Y,Z based on in between to even frames.


	IRP data structure = 194 bytes, but it is really two frames of data.

**************************************************************/



/**********  Instant Replay Data  Structures   ********************/

/* (seconds* tics/sec) = max frames in Instant Replay   */

#ifdef SATURNMODE

	#define SECONDS_IN_IRP 	9		// Saturn ONLY !!!!

#else

	#define SECONDS_IN_IRP 	9		// PSX or PC or N64 or SNES or...
//	#define SECONDS_IN_IRP 	4		// PSX or PC or N64 or SNES or...

#endif


//TICKS_PER_AI_FRAME should be 3 if frame rate = 20


/*****   WARNING  - MAX_IRP_FRAMES --MUST-- be an EVEN number	******/

#define MAX_IRP_FRAMES (SECONDS_IN_IRP * (60/TICKS_PER_AI_FRAME))


#define IRP_ALLOC_SIZE	((MAX_IRP_FRAMES/2) * sizeof(struct frameIRPData))



/****************************  End of File  - FBIRP.h **************/
