
/*******************************************************************

						File: FBPData.h

	Copyright 1996  GameTek, Inc.


	Author: Mike Knauer


	Equates, defines, etc.

	This file will be included in BOTH the data converter program
	AND in the actual PSX football program.



******************************************************************/


/*   here's some more of those redefinable macros	*/
/* pposmacro {PlayerPOSitionMACRO}
	 = ( enum, statstype, string,depthstring43,depthstring34)	*/

#define PlayPosMacros  \
\
pposmacro( QB,	SS_QB,QB,QB,QB) \
pposmacro( QB2,	SS_QB,QB,QB2,QB2) \
pposmacro( QB3,	SS_QB,QB,QB3,QB3) \
\
pposmacro( RR,	SS_REC,WR,RR,RR) \
pposmacro( LR,	SS_REC,WR,LR,LR) \
pposmacro( WR3,	SS_REC,WR,WR3,WR3) \
pposmacro( WR4,	SS_REC,WR,WR4,WR4) \
pposmacro( WR5,	SS_REC,WR,WR5,WR5) \
\
pposmacro( RTE,	SS_REC,TE,TE,TE) \
pposmacro( LTE,	SS_REC,TE,TE2,TE2) \
pposmacro( TE3,	SS_REC,TE,TE3,TE3) \
\
pposmacro( FB,	SS_RB ,FB,FB,FB) \
pposmacro( HB,	SS_RB ,HB,HB,HB) \
pposmacro( RB3,	SS_RB ,RB,RB3,RB3) \
pposmacro( FB2, SS_RB ,RB,RB4,RB4) \
\
pposmacro( RT,	SS_OL,OT,RT,RT) \
pposmacro( LT,	SS_OL,OT,LT,LT) \
pposmacro( RG,	SS_OL,OG,RG,RG) \
pposmacro( LG,	SS_OL,OG,LG,LG) \
pposmacro( CENTER,SS_OL,C,C,C) \
pposmacro( OL6,	SS_OL,OG,OG3,OG3) \
pposmacro( OL7,	SS_OL,OT,OT3,OT3) \
\
pposmacro( PUNT_RETURNER,   SS_KR,PR,PR,PR) \
pposmacro( KICK_RETURNER,   SS_KR,KR,KR,KR) \
pposmacro( KR3,				SS_KR,KR,KR3,KR3) \
\
pposmacro( PUNTER,	SS_PUNTER,P,P,P) \
pposmacro( KICKER,	SS_KICKER,K,K,K) \
\
pposmacro( DLE,	SS_DEF,DE,DRE,DRE) \
pposmacro( DLT,	SS_DEF,DT,DRT,NG) \
pposmacro( DRT,	SS_DEF,DT,DLT,NG2) \
pposmacro( DRE,	SS_DEF,DE,DLE,DLE) \
pposmacro( DL5,	SS_DEF,DT,DT3,NG3) \
pposmacro( DL6,	SS_DEF,DE,DE3,DE3) \
\
pposmacro( OLLB,SS_DEF,LB,RLB,ORLB) \
pposmacro( ILLB,SS_DEF,LB,MLB2,IRLB) \
pposmacro( IRLB,SS_DEF,LB,MLB,ILLB) \
pposmacro( ORLB,SS_DEF,LB,LLB,OLLB) \
pposmacro( LB5,	SS_DEF,LB,MLB3,ILB3) \
pposmacro( LB6,	SS_DEF,LB,OLB2,OLB3) \
\
pposmacro( FS,	SS_DEF,FS,FS,FS) \
pposmacro( SS,	SS_DEF,SS,SS,SS) \
\
pposmacro( RC,	SS_DEF,CB,LC,LC) \
pposmacro( LC,	SS_DEF,CB,RC,RC) \
pposmacro( NB,	SS_DEF,DB,NB,NB) \
pposmacro( DB,	SS_DEF,DB,DB,DB) \
pposmacro( DB7,	SS_DEF,CB,CB3,CB3) \
pposmacro( DB8,	SS_DEF,DB,S3,S3) \



/***********************************************************************

			P L A Y E R S  (POSITIONS)   O N    A   T E A M

	Here are the players on each team.

	I know enum for be easier, but I want to know the numbers!

------------------------------------------------------------------------*/

#define pposmacro(enum,stattype,pos_string,depth_string43,depth_string34)	enum,
enum playersonteam {
	PlayPosMacros
	TOTAL_PLAYERS_ON_TEAM   // always last - 47
};
#undef pposmacro



#if 0	//  ****  following for reference only - might be incorrect ***

#define QB		ZERO	/* Quarterback (duh)	*/
#define QB2		1	/* backup quarter back		*/
#define QB3 	2

#define RR		3	/* right receiver  			*/
#define LR		4	/* left receiver			*/
#define WR3		5	/* wide receiver 3          */
#define WR4		6	/* wide receiver 4        	*/
#define WR5		7	/* wide receiver 5          */

#define RTE		8	/* right tight end		    */
#define LTE		9	/* left tight end           */
#define TE3		10	/* extra tight end          */

#define FB		11	/* full back				*/
#define HB		12	/* half back                */
#define RB3		13	/* HB2 extra running back		*/
#define FB2 	14

#define RT		15	/* offensive right tackle	*/
#define LT		16	/* offensive left tackle	*/
#define RG		17	/* offensive right guard	*/
#define LG		18	/* offensive left guard		*/
#define CENTER	19	/* offensive center			*/
#define OL6		20	/* extra offensive lineman	*/
#define	OL7		21

#define PUNT_RETURNER   22
#define KICK_RETURNER   23
#define KR3 	24	// back up KR & PR

#define PUNTER  25
#define KICKER  26	// kicker on both off.(FG) and def(KO)

#define DLE		27	/* defensive left end		*/
#define DLT		28	/* defensive left tackle	*/
#define DRT		29	/* defensive right tackle	*/
#define DRE		30	/* defensive right end      */
#define DL5		31	/* extra defensive line     */
#define DL6 	32	/* extra,extra defensive line     */

#define OLLB	33	/* outside left linebacker  */
#define ILLB	34	/* inside left linebacker   */
#define IRLB	35	/* inside right linebacker  */
#define ORLB	36	/* outside right linebacker */
#define LB5		37	/* extra linebacker			*/
#define LB6 	38	/* extra,extra linebacker			*/

#define FS		39	/* free safety				*/
#define SS		40	/* strong safety			*/

#define RC		41	/* right cornerback			*/
#define LC		42	/* left cornerback			*/
#define NB		43	/* nickel back				*/
#define DB		44	/* dime back				*/
#define DB7		45	/* extra defensive back		*/
#define DB8 	46	/* extra,extra defensive back		*/


#define TOTAL_PLAYERS_ON_TEAM   47

#endif

#define DB6			DB
#define START_DEF	DLE
#define MLB			IRLB	/* middle linebacker	*/
#define	HB2			RB3
#define	HB3			FB2
#define	K			KICKER
#define	P			PUNTER
#define PR			PUNT_RETURNER
#define KR			KICK_RETURNER
#define	TE1			RTE
#define TE2			LTE
#define C 			CENTER
#define LOLB		OLLB
#define LILB		ILLB
#define RILB		IRLB
#define ROLB		ORLB

//  skin colors
#define LWHT 0
#define DWHT 1
#define LBLK 2
#define DBLK 3


#define LHQB 	0x04	// bit flags in skin colors
#define GLOVES  0x08    // bit flags in skin colors

#define	FA		0x10

#define R  0		// rookie


#define	PD_WEIGHT_OFFSET	150  	// weight 0 in DB actually is 150
#define	PD_HEIGHT_OFFSET	66      // height 0 in DB actually is 5'6"
#define	PD_YEAR_OFFSET		50      // start year is 1950 + data

#define	NUM_QBs		3
#define	NUM_RBs		4
#define	NUM_RECs	8
#define	NUM_OLs		7
#define	NUM_DEFs	20
#define	NUM_KRs		3
#define	NUM_Ps		1
#define	NUM_Ks		1

#define	START_POS_QBs		0
#define	START_POS_RBs		11
#define	START_POS_RECs		3
#define	START_POS_OLs		15
#define	START_POS_DEFs		27
#define	START_POS_KRs		22
#define	START_POS_Ps		25
#define	START_POS_Ks		26

//  is the following portable???
/*   ... no...
#if	(NUM_QBs+NUM_RBs+NUM_RECs+NUM_OLs+NUM_DEFs+NUM_KRs+NUM_Ps+NUM_Ks) != TOTAL_PLAYERS_ON_TEAM
#error Number of Players do not add up
#endif
*/
/*-------------------------------------------------------------------*/


#define PNAME_LEN	22	// old was 21
#define CNAME_LEN	20  	//college name length

#define MAX_NUM_RATINGS_PER_PLAYER	8
#define MAX_NUM_ROMSTATS_PER_PLAYER	10

struct pdata_t {	// output format for PSX multifiles

WORD	playernum;	// actual league player num (range = 0 - (#teams * #player per team))
WORD	collegeindex;
BYTE	pname[PNAME_LEN];

//BYTE	collegename[CNAME_LEN];	use index into separate data file

WORD	salary;		// x1000

#ifdef SATURNMODE 	// bit fields are "backwards" on Saturn
UWORD 	gloves:1;			//1 0-1 Gloves on player
UWORD 	leftqb:1;			//1 0-1 Left handed quarterback
UWORD	weight:8;         //8 0-255(150-405)  **** add offset ***
UWORD	position:6;   		//6 0-47

UWORD	skincolor:2;      //2 0-3
UWORD	birthyear:5;      //5 0-31(1950-1981)
UWORD	birthday:5;       //5 1-31
UWORD	birthmonth:4;     //4 1-12

UWORD	height:4;			//4 0-15(66-81) 	**** add offset ***
UWORD	yearsinleague:5;	//5 0-31 	0 = rookie
UWORD	jerseynum:7;		//7 0-99

#else	// PC tester, PC creation tool, or PSX
UWORD	position:6;   		//6 0-47
UWORD	weight:8;         //8 0-255(150-405)  **** add offset ***
UWORD	leftqb:1;			//1 0-1 Left handed quarterback
UWORD	gloves:1;			//1 0-1 Gloves on player

//  below ordered using bitfields for maximum compression
UWORD	birthmonth:4;     //4 1-12
UWORD	birthday:5;       //5 1-31
UWORD	birthyear:5;      //5 0-31(1950-1981)
UWORD	skincolor:2;      //2 0-3

UWORD	jerseynum:7;		//7 0-99
UWORD	yearsinleague:5;	//5 0-31 	0 = rookie
UWORD	height:4;			//4 0-15(66-81) 	**** add offset ***
#endif

BYTE	ratings[MAX_NUM_RATINGS_PER_PLAYER];			// 0-127 = 7bits*8ratings = 7 bytes

WORD	mypstats[MAX_NUM_ROMSTATS_PER_PLAYER];		// 1995 season stats - (constants)

WORD	reserved;		// future use
};

typedef struct pdata_t specificplayerdata;

#ifdef __MSDOS__
typedef struct pdata_t huge *lgplyrPTR;
#else		// PSX
typedef struct pdata_t * lgplyrPTR;	// no HUGE on PSX
#endif

enum playerratings {	// default QB ratings
	SPEED_RATE,
	STRENGTH_RATE,
	REACTION_RATE,
	HANDS_RATE,
	SCRAMBLE_RATE,
	ARMSTRENGTH_RATE,
	ACCURACY_RATE,
	INTELLIGENCE_RATE
};


#define AGILITY_RATE	SCRAMBLE_RATE	// non QB RB, Rec
#define	RUNBLOCK_RATE	ARMSTRENGTH_RATE
#define	PASSBLOCK_RATE	SCRAMBLE_RATE


#define	RUSH_RATE		SCRAMBLE_RATE
#define	TACKLE_RATE		ARMSTRENGTH_RATE

#define	LEGSTRENGTH_RATE		SCRAMBLE_RATE
#define	KICKACCURACY_RATE		ARMSTRENGTH_RATE


#include        "fbstats.h"


struct teamdatafile {		// copy of data file stored on CD

	struct pdata_t	PlayerROMData[TOTAL_PLAYERS_ON_TEAM];
	WORD	allplyrstats[MAX_NUM_STATS_1TEAM];		// no "compression" here
	WORD	alloppplyrstats[MAX_NUM_STATS_1TEAM];	// opposition stats
};



struct colleges
{
	BYTE collegename[CNAME_LEN];
};


//VAR (WORD, LeagueRoster[NUM_TEAMS_IN_LEAGUE][TOTAL_PLAYERS_ON_TEAM]);

#define MAX_PLAYERS_IN_LEAGUE ((NUM_TEAMS_IN_LEAGUE+1)*TOTAL_PLAYERS_ON_TEAM)

/************************ End of File ***********************************/
