/**************************************************************


					FBSTRING.C

	AUTHOR: Bobby King        Start Date: 5/5/95
	Modify Date:


	Copyright 1995  GameTek, Inc.



	This file contains INITIALIZED global variables dealing with strings.
	That is, Play Names, formation names, etc.



	Stick this in your project file.



	Also see "FB_GRAM.H"  - an include file with all of these
	variables as EXTERN.

**************************************************************/


#include  "fbequ.h"
//#include  "fbplays.h"


/*Names of the plays Created by Nick	*/
/*   WARNING - Play names are based on PlayNUM, not based on formation */

BYTE *PlayNames[] ={
/* 0 "GOAL LINE"*/
 "Option Pass", "QB Sneak", "FB Dive",
 "Naked Bootleg", "HB Leap", "Goalline Flood",
 "Tackle Eligible", "End Sweep", "Cross Block",
#if	NEWPLAYS1
 "P/A Fade", "HB Power", "HB Trap",
#endif

"Wishbone Dive","Wishbone P/A","Wishbone Sweep",

/* 1 "WISH BONE"*/
 "FB Off Tackle", "Roll Out", "Triple Option",
 "Power HB Dive", "HB Screen", "Student Body",
 "10 Yard Curl", "FB Misdirection", "P/A Seem",
 "Quick Pitch", "TE Bomb", "Draw",

#if	NEWPLAYS1

 "Draw2", "Draw3", "Draw4",
#endif

/* 2 "POWER I"*/
 "FB Off Tackle", "Roll Out", "Pitch Sweep",
 "Power HB Dive", "HB Screen", "Double Option",
 "10 Yard Curl", "FB Misdirection", "P/A Seem",
 "FB Quick Pitch", "TE Bomb", "Draw",

#if	NEWPLAYS1
 "Draw2", "Draw3", "Draw4",
#endif

/* 3 "SHIFTED I"*/
 "HB Off Tackle", "Roll Out", "Pitch Sweep",
 "Power HB Run", "FB Screen", "FB Sweep",
 "10 Yard Curl", "HB Misdirection", "P/A Seem",
 "FB Quick Pitch", "TE Bomb", "Draw",
#if	NEWPLAYS1
 "FB Counter", "Corner Post", "QB Waggle",
#endif

/* 4 "I SLOT"*/
 "Flea Flicker", "P/A Crosses", "HB Run Middle",
 "Bomb", "FB Power", "Motion Reverse",
 "Corner Fade", "QB Draw", "TE Fly",
 "TE Screen", "Crack Back", "HB Center Trap",
#if	NEWPLAYS1
"Slant Cross","Pick Pass","FB Dive",
#endif

/* 5 "ONE BACK"*/
 "Lead Push", "Short Post", "P/A Cross",
 "10 Yard Curls", "Sweep", "Roll Out Flood",
 "Draw", "Screen", "P/A Bootleg",
 "TE Corner", "Counter Pitch", "Power Lead",
#if	NEWPLAYS1
 "HB Toss", "QB Waggle", "Corner Post",
#endif

/* 6 "H BACK"*/
 "QB Draw", "Post Corner", "Reverse",
 "HB Crack Sweep", "HB Center Trap", "HB Flat",
 "Flea Flicker", "P/A Crosses", "Quick Outs",
 "Bomb", "Strong Pitch", "TE Screen",
#if	NEWPLAYS1
"HBack Flat","Pick Pass","HBack Run",
#endif

/* 7 "I FORM"*/
 "Counter Pull", "Long Bomb", "HB Option",
 "FB Punch", "Strong Pitch", "P/A Rollout",
 "Quick Slant", "Pitch Weak", "Out and Ups",
 "HB Screen", "Power Blast", "P/A HB Fly",
#if	NEWPLAYS1
 "Bounce Out", "TE Post", "P/A Chair",
#endif

/* 8 "PROSET"*/
 "Counter Pull", "Long Bomb", "HB Option",
 "FB Punch", "Strong Pitch", "P/A Rollout",
 "Quick Slant", "Pitch Weak", "Out and Ups",
 "HB Screen", "Power Blast", "HB Fly",
#if	NEWPLAYS1
 "Inside Slant", "TE Post", "P/A Chair",
#endif

/* 9 "WEST COAST"*/
 "Rollout Flood", "Motion Pitch", "10 Yard Curl",
 "Pass Back Right", "Reverse", "P/A Slant",
 "Bomb", "No Back Pass", "QB Draw",
 "CB Burner", "Short Post", "Off Tackle",
#if	NEWPLAYS1
"HB Flare","Sprint Handoff","Slant Clear",
#endif

/* 10 "SHOTGUN"*/
 "Rollout Gun", "Swing Pass", "Run Gun Wide",
 "Short Cross", "HB Snap", "Hail Mary",
 "Shovel Pass", "Pooch Kick", "Deep Cross",
 "WR Screen", "Delayed Draw", "Short Clearout",
#if	NEWPLAYS1
"Delay Toss","TE Short Post","Clear Flat",
#endif

/* 11 "TRIPS"*/
 "HB Flat", "QB Draw", "WR Comeback",
 "Slant Cross", "Pitch Away", "Pick Pass",
 "P/A Cross", "Center Trap", "Flea Flicker",
 "Out and Under", "Reverse", "Flanker Curl",
#if	NEWPLAYS1
 "Off Guard", "Clear Flat", "Post Iso",
#endif

/* 12 "RUN AND SHOOT"*/
 "Short Shoot", "QB Draw", "Medium Shoot",
 "P/A Cross", "Flea Flicker", "Center Trap",
 "Long Shoot", "Bomb", "Pitch Back",
 "Motion Flat", "Reverse", "HB Curl",
#if	NEWPLAYS1
 "Off Guard", "HB Flat", "Post Iso",
#endif

/* 13 "OFF SPECIAL TEAMS"*/
 "Fake FG Run", "Field Goal", "Fake FG Pass",
 "Fake Punt Run", "Punt", "Fake Punt Pass",
 "Stop Clock", "QB Kneel", "Fake Stop Clock",


/****************Defenses*****************/
/* 23 "GOALINE DEFENSE"*/
 "Outside Crunch", "Goal Line Deep", "House Party",
 "Cheat Left", "Short Zone", "Cheat Right",
 "Safety Gamble", "Fake Gamble", "Stuff Middle",
 "Goal Line Man", "Shadow Backs", "Outside Contain",

/* 24 "4-3"*/
 "Out-In Blitz", "4-3 Deep Corner", "Stunts",
 "SS Blitz", "3 Deep Safety", "Fake SS Blitz",
 "Man to Man", "Zone Left", "Wide Zone",
 "Combat Zone", "Two Deep Zone", "Left Blitz",

/* 25 "3-4"*/
 "Inside Blitz", "3-4 Deep Cloud", "Stunt Blitz",
 "Fake FS Blitz", "Deep Sky", "FS Blitz",
 "Straight Man", "CB Blitz", "Center Zone",
 "Suicide Blitz", "Shadow Zone", "Outside Blitz",

/* 26 "NICKEL"*/
 "Nickel Prevent", "Nickel Man", "Prevent Blitz",
 "Key on HB", "Middle Zone", "Double WR",
 "Big Dog Eat", "Bump and Run", "Corner Cushion",
 "QB Spy", "Fake NB Blitz", "NB Blitz",

/* 27 "DIME"*/
 "Prevent", "Dime Man", "Four Deep",
 "Prevent Right", "Inside Blitz", "Double Wides",
 "Blitz Man", "Double CB Blitz", "Prevent Left",
 "Fake 2DB Blitz", "Blitz Zone", "Two DB Blitz",

/* 28 "SPECIAL"*/
 "Double Outside", "Punt Return", "Punt Block",
 "11 Man Rush", "FG Block", "Watch Fake",

/***   Kickoffs  ******/
 "Return Spread",
 "Return Normal",
 "Return Hands",


 "Onside Left",
 "Normal Kickoff",
 "Onside Right",


/* 29 "EDITED - Team 0"*/
/**** WARNING - EDITED PLAY NAMES MUST BE 15 CHARS !!!*/
 "Special Edit 00", 	// placeholder for Team 0 edited play names
 "Special Edit 01",
 "Special Edit 02",
 "Special Edit 03",
 "Special Edit 04",
 "Special Edit 05",
 "Special Edit 06",
 "Special Edit 07",
 "Special Edit 08",
 "Special Edit 09",

 "Special Edit 10",
 "Special Edit 11",
 "Special Edit 12",
 "Special Edit 13",
 "Special Edit 14",
 "Special Edit 15",
 "Special Edit 16",
 "Special Edit 17",
 "Special Edit 18",
 "Special Edit 19",

 "Special Edit 20",
 "Special Edit 21",
 "Special Edit 22",
 "Special Edit 23",

/**** WARNING - EDITED PLAY NAMES MUST BE 15 CHARS !!!
	ALSO these default names MUST be unique or else compiler merges
	similar names (i.e. 2 pointers to same name)	*/

/* 30 "EDITED - Team 1"*/
 "Special Edit 24",		// placeholder for Team 1 edited play names
 "Special Edit 25",
 "Special Edit 26",
 "Special Edit 27",
 "Special Edit 28",
 "Special Edit 29",

 "Special Edit 30",
 "Special Edit 31",
 "Special Edit 32",
 "Special Edit 33",
 "Special Edit 34",
 "Special Edit 35",
 "Special Edit 36",
 "Special Edit 37",
 "Special Edit 38",
 "Special Edit 39",

 "Special Edit 40",
 "Special Edit 41",
 "Special Edit 42",
 "Special Edit 43",
 "Special Edit 44",
 "Special Edit 45",
 "Special Edit 46",
 "Special Edit 47",


/*  Easter Egg Plays-Off	*/

 "Speed Test",
 "Accel Test",
 "Blocking Test",
 "Blocking Test",

 "Speed Test",
 "Accel Test",
 "Blocking Test",
 "Blocking Test",

 "Speed Test",
 "Accel Test",
 "Blocking Test",
 "Blocking Test",

/*  Easter Egg Plays-Def	*/
 "Def GL Null",
 "Def 4-3 Null",
 "Def 3-4 Null",
 "Def Nkl Null",

 "Def Dme Null",
 "Def Dm3 Null",
 "Def GL Null",
 "Def 4-3 Null",

 "Def 3-4 Null",
 "Def Nkl Null",
 "Def Dme Null",
 "Def Do Nothing",

};




/************************************************************

			 F O R M A T I O N    N A M E S

	Here are the formation strings used in the Play Call Screen


	We use our redefineable MACRO to extract the info we need.

	see file  "fbfrmdat.h" for more info

************************************************************/

//#define formmacro(xxx,yyy,zzz)	#zzz,
#define formmacro(positionformnum,PCformnum,string,OfforDef,offseq)	#string,
#define	ALL_FORMS_VALID


BYTE *FormationNames[] = {


#include "fbfrmdat.h"


};
#undef	ALL_FORMS_VALID

#undef formmacro


/***********************  end of  file - FBString.C  *********************/

