/***********************************************************************
*pledshl.h                                                             *
*Shell-play edit                                                       *
*                                                                      *
*Programmed by Nicolas Antczak                                         *
*Started on 3/14/1995                                                  *
************************************************************************
*Copyright (C) 1995 GameTek, inc                                       *
************************************************************************
*Modifications                                                         *
*                                                                      *
************************************************************************/

///////////////////////////////////////////////////////
// tom moved from shell.h

#define MEMCARD_MSG  "Insert Memory Card into Slot 1"
#define SELECT_MSG	"Select"
#define BACK_MSG	"Back"

typedef struct {
	Sint16 Formation;
	Sint16 BallCarrier;
	Sint16 Third;

	UBYTE Name[11];

	struct play	ThePlay;

	Uint16 Block[7];
	Uint16 Script[7];

	Sint16 Bitmap[7];
	Uint16 Color[7];

	Sint16 ARROWposX[7];
	Sint16 ARROWposY[7];
	Uint16 FORMposX[7];
	Uint16 FORMposY[7];
} PLAYEDIT;

///////////////////////////////////////////////////////

/*Defines*/
/*mode flags*/
#define NEW_EDIT_MODE                 0
#define SELECT_PLAY_TYPE_MODE         1
#define SELECT_FORMATION_MODE         2
#define SELECT_PASSING_PLAYS_MODE     3
#define SELECT_BALL_CARRIER_MODE	  4
#define SELECT_RUNNING_PLAYS_MODE	  5
#define ENTER_PLAY_NAME_MODE          6
#define SAVE_TO_CARD_MODE             7

#define FORMATIONS_MAX 13 /*how many formations for now*/

#define BLANK_PROMPT "                                   "	   /*blank string templates 35 char*/
#define BLANK_PLAY_NAME "               "	/*blank play name 15 char*/
#define BLANK_BUTTON_PROMPT "            "  /*button prompt 12 char*/

#define SCREEN_TEMPLATE  0	 /*template reference numbers*/
#define SCREEN_TEMPLATE2 1	 /*template reference numbers*/
#define SCREEN_TEMPLATE3 2	 /*template reference numbers*/
#define SCREEN_TEMPLATE4 3	 /*template reference numbers*/
#define SCREEN_TEMPLATE5 4	 /*template reference numbers*/
#define ARROWS_TEMPLATE  5

#define XSCREENORG	122		 /*upper left hand corner of the screen*/
#define YSCREENORG	44

#define XPLAYSIZE	128		 /*play formation size*/
#define YPLAYSIZE	68

#define XORIGIN	136			 /*upper left corner of the alphabet panel*/
#define YORIGIN	88
#define XSWEEP	16			 /*by how much to move alphabet cursor*/
#define YSWEEP	16
#define XASCIIMAX 15         /*How many letters horizontally*/
#define YASCIIMAX 3

#define SCALEFACTOR 2		 /*scale bitmaps by how much*/

#define AVG_CHAR_WIDTH 12	 /*avg char width used to calculate widh of the menu panel*/

#define PROMPT_ITEM_MAX 5	 /*maximum number of prompt strings*/

#define WATCH_CARD 0		 /*how to watch card */
#define DONT_WATCH_CARD 1
#define WATCH_ONLY_CARD 2

/*play manager define*/
#define MAX_EDITED_PLAYS 24      /*maximum edited plays*/
#define PLAY_MAN_SAVE 0      /*play manager call flags*/
#define PLAY_MAN_LOAD 1

#define PLAY_MAN_X 96        /*origin of the menmu system*/
#define PLAY_MAN_Y 20

/*play manager mode flags*/
#define PMSAVE_SCROLL_FILES 0

/*menu colors*/
#define MENU_PROMPT_COLOR   2	// Nicks old equates
#define NORMAL_MENU    		0

#define MENU_ITEM_MAX       64           /*maximum menu items*/

/*************************END OF FILE TSELSHL.H**************************/
