extern void EndGameShell(BYTE mode);
extern void GetPositionString(BYTE *string, INT position);
extern INT InitViewPlayer(void);		// Player stats menu initialisation function
extern INT MainViewPlayer(void);		// Main processing for player stats displays
extern INT TermViewPlayer(void);		// Player stats termination function
extern void ViewPlayer(WORD team);	// Player stats display

extern void DisplaySubstitution(void);	//Wrapper for Tom to call
extern INT MainSubstitution(void);		// Main processing for substitution menus

extern void DoSubstituteMenu(void);	// Substitution specific processes
extern void UpdateSubstNameLines(UWORD group);

extern void UpdateRatings(UWORD player);
extern WORD MoveStatColumns(UWORD position, UWORD rlimit);
extern void PrintStatHeader(INT player, INT x, INT y);
extern void DrawStatColumns(UWORD xpos, UWORD ypos, UWORD player, WORD *statptr, BYTE absflag);

extern void SortLeaders(void);			// Sorts players by stat type
extern void DisplayPlLeaders(void);	// Displays sorted players
extern WORD GetPlyrStat(UWORD player, WORD *statptr);	// Obtains stat result for a players

extern INT InitPlyrLeader(void);		// Player leaders menu init function
extern INT TermPlyrLeader(void);		// Player leaders menu termination function
extern INT MainPlyrLeader(void);		// Main processing for player leaders menu
extern INT DisplayPlyrLeaders(void);

extern INT MainTradePlayer(void);
extern INT InitTradePlayer(void);
extern INT TermTradePlayer(void);
extern void DisplayTrading(INT team);
extern void ResetTradeDisplay(void);

extern LONG UseTradedTeam;

