#ifndef REFANIM_H
#define REFANIM_H 1
/**************************************************************
	Referee Animation numbers
	
	By Christopher G. Deel
**************************************************************/


#define REF_ANIM_DEFINES \
	RefGraphMac(REF_RUNNING_NUM, 8)  \
	RefGraphMac(REF_1STDOWN_NUM, 3)   \
	RefGraphMac(REF_PERSONAL_FOUL_NUM, 1)  \
	RefGraphMac(REF_STANDING_NUM, 1)  \
	RefGraphMac(REF_CLIPPING_NUM, 1)  \
	RefGraphMac(REF_ROUGH_KICKER_NUM, 1)  \
	RefGraphMac(REF_ROUGH_PASSER_NUM, 1)  \
	RefGraphMac(REF_TOUCHDOWN_NUM, 1)  \
	RefGraphMac(REF_SAFTEY_NUM, 1)  \
	RefGraphMac(REF_PENALTY_REFUSED_NUM, 1)  \
	RefGraphMac(REF_OFFSIDE_NUM, 1)  \
	RefGraphMac(REF_INTERFERENCE_NUM, 1)  \
	RefGraphMac(REF_INELLIGIBLE_RCVR_NUM, 1)  \
	RefGraphMac(REF_ILLEGAL_HANDS_NUM, 1)  \
	RefGraphMac(REF_FALSE_START_NUM, 1)  \
	RefGraphMac(REF_DELAY_NUM, 1)  
	
	
#define RefGraphMac(anim, frames) anim,	

enum RefGraphicEnum {	
	REF_ANIM_DEFINES
	MAX_REF_ANIMS	
};
#undef RefGraphMac


#if PLYRANIM_C

#define RefGraphMac(anim, frames) frames,	
char gRefAnimFrames[] =   // This generates Data
{
 	REF_ANIM_DEFINES
};
#undef RefGraphMac

#undef REF_ANIM_DEFINES

#endif //PLYRANIM_C

#endif //REFANIM_H
