
#include "prjtypes.h"
#include "simtable.h"


RunSimTable_t RunSimTable[2][5] =
{
	{  // RUN_INSIDE
	   // fumb loss no g 1-5  6-10 1020 20+
		{ 20,  80, 150, 470, 200,  50,	30},	// ALL_PURPOSE 
		{ 40, 200, 250, 350, 100,  40,  20},	// STOP_RUN 
		{ 20,  50, 100, 500, 250,  50,  30},	// STOP_PASS_SHORT
		{ 30,  20,  40, 550, 250,  70,  40},	// STOP_PASS_DEEP
		{ 40, 150, 110, 330, 230,  80,  60},	// BLITZ
	},
	{  // RUN_OUTSIDE
	   // fumb loss no g 1-5  6-10 1020 20+
		{ 20, 120, 150, 450, 160,  60,  40},    // ALL_PURPOSE    
		{ 40, 220, 250, 360,  80,  30,  20},    // STOP_RUN         
		{ 20,  80, 110, 450, 220,  70,  50},    // STOP_PASS_SHORT
		{ 30,  20,  50, 520, 240,  80,  60},    // STOP_PASS_DEEP 
		{ 30, 160, 120, 320, 200, 100,  70},    // BLITZ          
	}
};

PassSimTable_t PassSimTable[3][5] =
{
	{ // PASS_SHORT
	  // fumb sack inc  int  com
		{ 10,  40, 350,  30, 570},	// ALL_PURPOSE    
		{ 10,  50, 260,  10, 670},	// STOP_RUN       
		{ 10,  60, 440,  40, 450},	// STOP_PASS_SHORT
		{ 10,  60, 400,  30, 500},	// STOP_PASS_DEEP 
		{ 20,  80, 220,  20, 660},	// BLITZ          
	},
	{  // PASS_MEDIUM
		{ 10,  50, 420,  40, 480}, 	// ALL_PURPOSE    
		{ 10,  40, 300,  20, 630},	// STOP_RUN       
		{ 10,  60, 480,  40, 410},	// STOP_PASS_SHORT
		{ 10,  60, 480,  40, 410},	// STOP_PASS_DEEP 
		{ 20, 100, 330,  30, 520},	// BLITZ          
	},
	{  // PASS_DEEP
		{ 10,  50, 630,  50, 260}, 	// ALL_PURPOSE    
		{ 10,  50, 590,  30, 320}, 	// STOP_RUN       
		{ 10,  70, 630,  50, 240}, 	// STOP_PASS_SHORT
		{ 10,  70, 700,  60, 160}, 	// STOP_PASS_DEEP 
		{ 10, 210, 640,  40, 100}, 	// BLITZ          
	}
};
	
	
	
