/****************************************************
	Play simulation Tables
	
*****************************************************/	


typedef struct		// (overlap will help reward good runners)
{
	WORD Fumble;	// % fumble (should include yards gained -5 to 10)
	WORD Loss;		// % loss (-5 to 1)
	WORD NoGain;	// % no gain (-1 to 2)
	WORD Gain5;		// % Gain 1 to 5 yards (0 to 7)
	WORD Gain10;	// % Gain 6 to 10 yards	(3 to 12)
	WORD Gain20;	// % Gain 10 to 20 yards (8 to 20)	     
	WORD GainMax;	// % Gain more than 20 yards (20 to 99)
} RunSimTable_t;

typedef struct
{
	WORD Fumble;		// % fumble
	WORD Sack;			// % Sack
	WORD Incomplete;	// % Incomplete
	WORD Interception;	// % Interception
	WORD Complete;		// % Complete
} PassSimTable_t;

extern RunSimTable_t RunSimTable[2][5];
extern PassSimTable_t PassSimTable[3][5];
